package dbManWeb;

use strict;
use vars qw/$VERSION $AUTOLOAD $type_info %Types/;
$VERSION = '0.1.0';
use nDBI;
use CGI;
1;

sub new {
	my ($class,$title) = @_;
	my $obj = bless { title => $title, page => '', ndbi => undef, 
		foot => '', log_ok => undef },$class;
	$obj->{cgi} = new CGI;
	if ($obj->param('db_login') and $obj->param('db_password')) {
		my $logstr = nDBI::ndbi_login_string(
			$obj->param('db_driver'),
			$obj->param('db_database'),
			$obj->param('db_host'),
			$obj->param('db_port'));
		if ($obj->param('db_proxy') == 1) {
			$logstr = 'dbi:Proxy:hostname='.
				$obj->param('db_proxy_host').";port=".
				$obj->param('db_proxy_port').";dsn=DBI:".
				$obj->param('db_driver').":".$logstr;
		} else {
			$logstr = 'dbi:'.$obj->param('db_driver').':'.$logstr;
		}
		my $f = 'connect';  my @args = ();
		if ($obj->param('db_proxy') == 2) {
			$f = 'proxy';  @args = ($obj->param('db_proxy_host'),
				$obj->param('db_proxy_port'));
		}
		if ($obj->{ndbi} = nDBI->$f(@args,$logstr,
			$obj->param('db_login'),$obj->param('db_password'),
			{ PrintError => 0,RaiseError => 0,AutoCommit => 1 })) {	
			$obj->{log_ok} = 1;
			$obj->{ndbi}->ndbi_set(LongReadLen => 1000000);
			$type_info = $obj->{ndbi}->type_info_all;
			if ($obj->param('db_driver') eq 'Pg') {
				my $rt = $obj->{ndbi}->selectall_arrayref(
					q!select typname,oid from pg_type 
						where typtype = 'b'!);
				for (@$rt) { $Types{$_->[1]} = $_->[0]; }
		        }

    			my %info = %{shift @$type_info};
    		    	my $data_type = $info{DATA_TYPE};
   			my $type_name = $info{TYPE_NAME};
 	       		for (@$type_info) {
         	        	my @type = @$_;
               			$type[$data_type] = 0 unless $type[$data_type];
               			$Types{$type[$data_type]} = $type[$type_name];
    			}
		} else {
			$obj->error("Can't connect to database '".$obj->param('db_database')."' on '".$obj->param('db_host').":".$obj->param('db_port')."' as '".$obj->param('db_login')."' - ".nDBI->errstr.'!');
			exit;
		}
	} else {
		$obj->log_window;
		exit;
	}
	return $obj;
}

sub DESTROY {
	my $obj = shift;
	print "Content-Type: text/html\n\n";
	print "<HTML><HEAD><TITLE>".$obj->{title}."</TITLE></HEAD>";
	$obj->{page} .= '<P><BR>'.$obj->{foot}.'<P>' if $obj->{foot};
	print "<BODY BGCOLOR=white TEXT=black LINK=blue VLINK=magenta ALING=green><TABLE BORDER=0 SPACING=0><TR><TD><A HREF=".'"./?'.$obj->req().'"'."><IMG SRC=../dbmanweb.jpg ALT=".'"dbMan online"'." BORDER=0></A></TD><TD VALIGN=bottom><TABLE BORDER=0><TR><TD><SMALL>".($obj->{log_ok}?'Connected to '.$obj->param('db_database').' on '.$obj->param('db_host').':'.$obj->param('db_port').' as '.$obj->param('db_login').(($obj->param('db_proxy') > 0)?(' through '.$obj->param('db_proxy_host').":".$obj->param('db_proxy_port').' using '.(($obj->param('db_proxy')==1)?'DBD::Proxy':'dbman-proxy')):'').'.':'Not connected to database.')."</SMALL></TD></TR></TABLE></TD></TR></TABLE><P><BR><BR>".$obj->{page}."<P><HR><BR><TABLE BORDER=0 WIDTH=100%><TR><TD><SMALL><A HREF=..>dbMan web site</A></SMALL></TD><TD ALIGN=right><SMALL>Hosted on <I>dbman.linux.cz</I>, dbMan online version <I>".$VERSION."</I>.</SMALL></TD></TR></TABLE></BODY></HTML>\n";
	$obj->{ndbi}->disconnect() if defined $obj->{ndbi};
}

sub AUTOLOAD {
	my ($obj,@p) = @_;
	$AUTOLOAD =~ s/dbManWeb:://;
	if ($AUTOLOAD =~ /^orig_(.*)/) {
		return $obj->{cgi}->$1(@p);
	} else {
		$obj->add($obj->{cgi}->$AUTOLOAD(@p));
	}
}

sub param {
	my ($obj,@p) = @_;
	return $obj->{cgi}->param(@p);
}

sub add {
	my $obj = shift;
	return $obj->{page} .= join '',@_;
}


# data { col_headings,col_headings_color,rows[] }
sub table {
	my $obj = shift;
	my $color = '#aaaaff';
	my $tbl_border="'1'";
	my $tbl_width='';

	my $data = { @_ };

	if ($data->{data}) { $data->{rows} = $data->{data}; }

	$tbl_border = $data->{table_border} if defined $data->{table_border};
	
	$tbl_width = " WIDTH='$data->{table_width}'" if defined $data->{table_width};

	my $tab = "<TABLE BORDER=$tbl_border$tbl_width>";	

	$color = $data->{col_headings_color} if defined $data->{col_headings_color};

	my @cwidths = ();
	@cwidths = @{$data->{col_widths}} if defined $data->{col_widths};

	# zahlavi tabulky
	if (defined $data->{col_headings}) {
		$tab .= '<TR>';
		for (@{$data->{col_headings}}) {
			$tab .= '<TH ALIGN=center BGCOLOR='.$color;
			my $w = shift @cwidths;
			$tab .= ' WIDTH='.$w if $w;
			$tab .= '>'.$_.'</TH>';
		}
		$tab .= '</TR>';
	}	

	for (@{$data->{rows}}) {
		$tab .= '<TR>';
		my %ref = ();

		for (@$_) {
			if (ref $_) { 
				%ref = %$_;	
			} else {     
				my $add = '';
				foreach my $tag (keys %ref) {
					$add .= " $tag=$ref{$tag}";
				}
				$tab .= '<TD' . $add . '>' . $_ . '</TD>';
				%ref = ();
			}
		}
		$tab .= '</TR>';
	}

	$obj->add($tab . '</TABLE>');
}

sub table_small {
	my $obj = shift;
	my $data = { @_ };
	if ($data->{data}) { $data->{rows} = $data->{data}; delete $data->{data}; }
	for (@{$data->{rows}}) {
		$_ = [ map { ref $_ ? $_ : "<SMALL><TT>$_</TT></SMALL>" } @$_ ];
	}
	return $obj->table(map { ($_,$data->{$_}) } keys %$data);
}

sub double {
	my ($obj,$data) = @_;
	
	use integer;
	my $d = @$data/2;
	no integer;
	my $zb = (@$data/2 == $d)?0:1;
	
	my @pomocne = @$data[@$data/2+$zb..$#$data];
	my $p = 0;  for (@{$data->[0]}) { ++$p unless ref $_; }
	my @p = ();  for (1..$p) { push @p,'&nbsp;'; }
	push @pomocne,[@p];
	@$data = @$data[0..@$data/2+$zb-1];
	
	for (@$data) { $_ = [@$_,{bgcolor => '#C0C0C0'},' &nbsp; ',@{shift @pomocne}];}

	return $data;	
}

sub begin_center {
	my $obj = shift;
	$obj->add('<CENTER>');
}

sub end_center {
	my $obj = shift;
	$obj->add('</CENTER>');
}

sub url {
	my $obj = shift;
	return $obj->orig_self_url;
}

sub error {
	my $obj = shift;
	$obj->{page} = '<FONT COLOR=red>'.join ("<BR>",@_).'</FONT>';
	exit;
}

sub log_window {
	my $obj = shift;
	$obj->startform(-action => './');
	$obj->desc(q!You are not logged to any database. You must specify some information about your connection. Then press Login button. Please select apropriert database driver, but only a few database driver are installed on this online server. Other drivers can be used with DBD::Proxy or dbman-proxy system.!);
	$obj->begin_center;
	$obj->orig_autoEscape(0);
	$obj->table(table_border => 0, rows => [ 
		[ 'Hostname: &nbsp; &nbsp; ', 
			$obj->orig_textfield(-name => 'db_host',
 				-maxlength => 50, -override => 1), 'port &nbsp; &nbsp; ',
			$obj->orig_textfield(-name => 'db_port',
				-maxlength => 8, -size => 8, -override => 1) ], 
		[ 'Driver: ', $obj->orig_popup_menu(-name => 'db_driver',
				-values => [ nDBI->all_drivers ],
				-override => 1) ], 
		[ 'Database: ', 
			$obj->orig_textfield(-name => 'db_database',
				-maxlength => 20, -override => 1) ], 
		[ 'Login: ', $obj->orig_textfield(-name => 'db_login',
				-maxlength => 16, -override => 1) ],
		[ 'Password: ', 	
			$obj->orig_password_field(-name => 'db_password',
				-maxlength => 16, -override => 1) ], 
		[ 'Proxying: ', 	
			$obj->orig_popup_menu(-name => 'db_proxy',
				-values => [ 0, 1, 2],
				-labels => { 0 => 'none', 1 => 'Use DBD::Proxy',
					2 => 'Use dbman-proxy' },
				-override => 1) ],
		[ 'Proxy hostname: ', 
			$obj->orig_textfield(-name => 'db_proxy_host',
				-maxlength => 20, -override => 1), 'port &nbsp; &nbsp; ',
			$obj->orig_textfield(-name => 'db_proxy_port',
				-maxlength => 20, -size => 8, -override => 1) ]
	]);
	$obj->p;
	$obj->submit('Login');
	$obj->end_center;
	$obj->endform;
}

sub req {
	my $obj = shift;
	if (defined $obj->{ndbi}) {
		my @out = ();
		for (qw/db_host db_port db_driver db_database db_login db_password db_proxy db_proxy_host db_proxy_port/) {
			push @out,"$_=".$obj->param($_) if $obj->param($_);
		}
		return join '&',@out;
	}
	return '';
}

sub reqform {
	my $obj = shift;
	if (defined $obj->{ndbi}) {
		for (qw/db_host db_port db_driver db_database db_login db_password db_proxy db_proxy_host db_proxy_port/) {
			$obj->hidden($_,$obj->param($_)) if $obj->param($_);
		}
	}
}

sub footer {
	my $obj = shift;
	$obj->{foot} .= join '<BR>',map { "<LI><I>$_</I>"; } @_;
}

sub desc {
	my $obj = shift;
	$obj->font({-color => 'green'},'<SMALL>'.join (' ',@_).'</SMALL>');
	$obj->p;
}

sub looks_like_number ($$) {
	my ($obj,$val) = @_;
	return nDBI::looks_like_number $val;
}

sub space {
	my $q = shift;
	$q->add(' &nbsp; &nbsp; &nbsp; ');
}
