package nDBD::Pg;

$VERSION = '0.0.3';
use nDBD;
@ISA = qw(nDBD);
1;

sub ndbd_oid {
	return "oid";
}

sub ndbd_oid_numeric {
        return 1;
}       

sub ndbd_describe {
	my ($obj,$db) = @_;
	return q!select a.attnum, a.attname, t.typname, a.attlen, a.attalign, 
			a.attbyval, a.attnotnull, a.atthasdef 
	         from pg_class c, pg_attribute a, pg_type t 
		 where c.relname = '!.$db.q!'
		 and a.attnum > 0 and a.attrelid = c.oid and a.atttypid = t.oid
    		 order by attnum!;
}

sub ndbd_create_table {
        my ($obj,$table) = @_;
	my $ref = $obj->{ndbi}->selectall_arrayref($obj->ndbd_describe($table));
	my $def = '';
	$def = join ", ",map { $_->[1] . " " . uc($_->[2]) } @$ref;	
	$def = " ($def)" if $def;
        return "CREATE TABLE $table$def";
}

sub ndbd_login_string {
        my ($database,$host,$port) = @_;
        return "dbname=$database" . ($host?";host=$host":"") 
			  	  . ($port?";port=$port":"");
}

