package nDBD::mysql;

$VERSION = '0.0.4';
use nDBD;
@ISA = qw(nDBD);
1;

sub _initialize {
	my $obj = shift;
	$obj->{oid_buffer} = {};	
}

sub ndbd_login_string {
        my ($database,$host,$port) = @_;
        return "database=$database" . ($host?";host=$host":"") 
				    . ($port?";port=$port":"");
}

sub ndbd_oid {
	my ($obj,$table) = @_;
	return $obj->{oid_buffer}->{$table} 
		if exists $obj->{oid_buffer}->{$table};
	my $r = $obj->{ndbi}->selectall_arrayref("describe $table");	
	my @candideP = ();  my @candideU = ();
	for (@$r) { 
		push @candideP,$_->[0] if $_->[3] eq 'PRI'; 
		push @candideU,$_->[0] if $_->[3] eq 'UNI'; 
	}
	if (scalar @candideP == 1) {
		$obj->{oid_buffer}->{$table} = shift @candideP;
		return $obj->{oid_buffer}->{$table};
	} elsif (scalar @candideU > 0) {
		$obj->{oid_buffer}->{$table} = shift @candideU;
		return $obj->{oid_buffer}->{$table};	
	}
	return undef;
}

sub ndbd_tables {
	my $obj = shift;
	return [ $obj->{ndbi}->func('_ListTables') ];	
}

sub ndbd_create_table {
        my ($obj,$table) = @_;
	my $ref = $obj->{ndbi}->selectall_arrayref($obj->ndbd_describe($table));
        my $def = '';
        $def = join ", ",map { $_->[0] . " " . uc($_->[1]) } @$ref;
        $def = " ($def)" if $def;
        return "CREATE TABLE $table$def";
}
