package plugOracle;

use strict;
use vars qw($VERSION $PLUGIN);
use Plugin;

$VERSION = '0.0.2';
1;

sub run {
	if ($PLUGIN->{dbsys} eq 'Oracle') {
		my $ref = $PLUGIN->{dbi}->selectall_arrayref(q!
				select table_owner from all_tables 
				group by table_owner order by table_owner!);
		my @schemas = ();  for (@$ref) { push @schemas,$_->[0]; }
		my $dialog = $PLUGIN->{top}->DialogBox(
			-title => 'Select schema', -buttons => 
			[ 'Select', 'Cancel' ] );
		my $listb = $dialog->Scrolled('Listbox',-scrollbars => 'e')
			->pack('-fill' => 'both', -expand => 'y');
		$listb->insert(0,@schemas);
		if ($dialog->Show() eq 'Select') {
			my ($sel) = $listb->curselection();
			main::do_sql("alter session set current_schema=" 
				. $schemas[$sel]) if defined $sel;
		}
	} else {
		main::error('Work only with Oracle');
	}
}

sub register {
	my ($class,$plugin) = @_;
	my $position0 = $plugin->add_to_menu;
	my $position1 = $plugin->add_to_menu('Select schema',\&run);
	$PLUGIN = $plugin;
	return bless { plugin => $plugin, position0 => $position0,
		position1 => $position1 },$class;
}

sub deregister { 
	my $obj = shift;
	$obj->{plugin}->remove_menu($obj->{position0});
	$obj->{plugin}->remove_menu($obj->{position1});
	1; 
}
