package plugPgSql;

use strict;
use vars qw($VERSION $PLUGIN);
use Plugin;

$VERSION = '0.0.1';
1;

sub vacuum {
	if ($PLUGIN->{dbsys} eq 'Pg') {
		main::do_sql('vacuum');
	} else {
		main::error('Work only with PgSQL');
	}
}

sub ldatabases {
	if ($PLUGIN->{dbsys} eq 'Pg') {
		main::do_sql('select * from pg_database order by datname');
	} else {
		main::error('Work only with PgSQL');
	}
}

sub systab {
	if ($PLUGIN->{dbsys} eq 'Pg') {
		main::do_sql(q!select relname from pg_class where relname ~ '^pg\_' order by relname!);
	} else {
		main::error('Work only with PgSQL');
	}
}

sub register {
	my ($class,$plugin) = @_;
	my $position0 = $plugin->add_to_menu;
	my $position1 = $plugin->add_to_menu('Vacuum',\&vacuum);
	my $position2 = $plugin->add_to_menu('List of databases',\&ldatabases);
	my $position3 = $plugin->add_to_menu('System tables',\&systab);
	$PLUGIN = $plugin;
	return bless { plugin => $plugin, position1 => $position1,
       		position2 => $position2, position3 => $position3,
       		position0 => $position0 },$class;
}

sub deregister { 
	my $obj = shift;
	$obj->{plugin}->remove_menu($obj->{position0});
	$obj->{plugin}->remove_menu($obj->{position1});
	$obj->{plugin}->remove_menu($obj->{position2});
	$obj->{plugin}->remove_menu($obj->{position3});
	1; 
}
